Package org.apache.commons.math3.ode

# Interface FirstOrderFieldDifferentialEquations<T extends RealFieldElement<T>>

Type Parameters:
  `T` - the type of the field elements

public interface FirstOrderFieldDifferentialEquations<T extends RealFieldElement<T>>
This interface represents a first order differential equations set.

This interface should be implemented by all real first order differential equation problems before they can be handled by the integrators `FirstOrderIntegrator.integrate(org.apache.commons.math3.ode.FirstOrderDifferentialEquations, double, double[], double, double[])` method.

A first order differential equations problem, as seen by an integrator is the time derivative `dY/dt` of a state vector `Y`, both being one dimensional arrays. From the integrator point of view, this derivative depends only on the current time `t` and on the state vector `Y`.

For real problems, the derivative depends also on parameters that do not belong to the state vector (dynamical model constants for example). These constants are completely outside of the scope of this interface, the classes that implement it are allowed to handle them as they want.

Since:
  3.6
See Also:
  - `FirstOrderFieldIntegrator`

## Method Summary

Modifier and Type
Method
Description
`T[]`
`computeDerivatives(T t, T[] y)`
Get the current time derivative of the state vector.
`int`
`getDimension()`
Get the dimension of the problem.
`void`
`init(T t0, T[] y0, T finalTime)`
Initialize equations at the start of an ODE integration.

## Method Details

### getDimension

int getDimension()
Get the dimension of the problem.

Returns:
  dimension of the problem

### init

void init(T t0, T[] y0, T finalTime)
Initialize equations at the start of an ODE integration.

This method is called once at the start of the integration. It may be used by the equations to initialize some internal data if needed.

Parameters:
  `t0` - value of the independent time variable at integration start
  `y0` - array containing the value of the state vector at integration start
  `finalTime` - target time for the integration

### computeDerivatives

T[] computeDerivatives(T t, T[] y)
Get the current time derivative of the state vector.

Parameters:
  `t` - current value of the independent time variable
  `y` - array containing the current value of the state vector
Returns:
  time derivative of the state vector